/**
 * 
 */
package eos.agents;

import eos.models.Baseline2Model;
import eos.models.Baseline2Model.*;
import eos.framework.*;
import java.util.*;

/**
 * A laborer who asks and sells for a fixed price.
 * 
 * @author Madelson
 */
public class BL2FixedPriceLaborer extends Baseline2Laborer {

    public static final double FOOD_THRESHOLD = 30;

    /**
     * Construct a FixedPriceLaborer. Must have first added Markets to economy.
     */
    public BL2FixedPriceLaborer(Economy economy, Map<String, Good> goods) {
        super(economy, goods);
    }

    /*
     * (non-Javadoc)
     * 
     * @see eos.models.Laborer#bid()
     */
    protected void baseLine2LaborerSubclassAct() {
        
        if (this.food.getQuantity() < FOOD_THRESHOLD) {
            double panicAdjust = this.food.getQuantity() < 0.25 * FOOD_THRESHOLD ? 0.01 : 0.0;
            
            // buy food
            foodMarket.addBuyOffer(this, FOOD_THRESHOLD - food.getQuantity(),
                    Baseline2Model.HISTORICAL_FOOD_PRICE + panicAdjust);

            // sell labor
            double laborQuantity = (FOOD_THRESHOLD - food.getQuantity())
                    * Baseline2Model.HISTORICAL_FOOD_PRICE / Baseline2Model.HISTORICAL_LABOR_PRICE;
            laborQuantity = Math.min(LABOR_ALLOWANCE, laborQuantity);

            // if (laborQuantity >= 0.5 * LABOR_ALLOWANCE)
            laborMarket.addSellOffer(this, laborQuantity, Baseline2Model.HISTORICAL_LABOR_PRICE);
        }
//        if (this.economy.getRandom().nextInt(10) == 0
//                && this.labor.getQuantity() > 0.0) { // a one in ten chance
//            laborMarket
//                    .addSellOffer(this, this.labor.getQuantity(), Baseline2Model.HISTORICAL_LABOR_PRICE);
//        }
    }

}
