/**
 * 
 */
package eos.agents;

import java.util.Map;

import eos.framework.Economy;
import eos.framework.Good;
import eos.models.Laborer;
import eos.models.Baseline2Model.Baseline2Farm;
import static eos.models.Baseline2Model.*;

/**
 * @author madelson
 * 
 */
public class BL2LaborDCFarm extends Baseline2Farm {

    /**
     * @param economy
     * @param goods
     */
    public BL2LaborDCFarm(Economy economy, Map<String, Good> goods) {
        super(economy, goods);
        // TODO Auto-generated constructor stub
    }

    /*
     * (non-Javadoc)
     * 
     * @see eos.models.Baseline2Model.Baseline2Farm#baseLine2FarmSubclassAct()
     */
    protected void baseLine2FarmSubclassAct() {
        // sell food
        if (this.food.getQuantity() > 0.0)
            this.foodMarket.addSellOffer(this, this.food.getQuantity(),
                    HISTORICAL_FOOD_PRICE);

        // buy labor
        if (this.laborMarket.getLastMarketPrice() <= 0.0
                || this.foodMarket.getLastMarketPrice() <= 0.0)
            this.laborMarket.addBuyOffer(this, MAX_PRODUCTION
                    / LABOR_PRODUCTIVITY, HISTORICAL_LABOR_PRICE);
        else {
            double lastFood = 0.0;
            for (double d = Laborer.LABOR_ALLOWANCE; this.money.getQuantity() > 0.0; d += Laborer.LABOR_ALLOWANCE) {
                double marginalFood = convertToFood(d) - lastFood;

                if (marginalFood < Laborer.EAT_AMOUNT / 2.0)
                    break;
                
                this.laborMarket.addBuyOffer(this, Laborer.LABOR_ALLOWANCE,
                        marginalFood * this.foodMarket.getLastMarketPrice());

                lastFood += marginalFood;
            }
        }
    }

}
